Attribute VB_Name = "Module1"
Option Explicit


Const BeginnerCellsAcross As Integer = 8
Const BeginnerCellsDown As Integer = 8
Const BeginnerBombNbr As Integer = 10
Const BevelThickness As Integer = 2
Const BorderWidth As Integer = 8
Public Const BorderGirth As Integer = 2 * BevelThickness + BorderWidth
Const TwipsPerPixel As Integer = 15
Const FormSideBorderWidth As Integer = 6
Const FormTopBorderWidth As Integer = 44

Public Enum DRGPlayingLevels
    DRGBeginner = 0
    DRGIntermediate = 1
    DRGExpert = 2
    DRGCustom = 3
End Enum

Private Type CellStatus
    Bomb As Boolean
    Clicked As Boolean
    Marked As Boolean
    Flagged As Boolean
    BombsAbutting As Integer
End Type

Public CellArray() As CellStatus

Public BestTime As Integer
Public BestTimes(3) As Integer
Public BestNames(3) As String
Dim BlankCellStack() As Variant
Dim BombCnt As Integer
Public BombNbr As Integer
Public CellsAcross As Integer
Public CellsDown As Integer
Public ClickedCnt As Integer
Public FaceLeft As Integer
Public FaceHeight As Integer
Public FaceTop As Integer
Public FaceWidth As Integer
Public FlagCnt As Integer
Public FlagCounterHeight As Integer
Public FlagCounterLeft As Integer
Public FlagCounterTop As Integer
Public FlagCounterWidth As Integer
Public FrmLeft As Integer
Public FrmTop As Integer
Public GameOver As Boolean
Public GameStarted As Boolean
Public NewBestTime As Boolean
Public NumberWidth As Integer
Public PlayFieldHeight As Integer
Public PlayFieldLeft As Integer
Public PlayFieldTop As Integer
Public PlayFieldWidth As Integer
Public PlayLevel As DRGPlayingLevels
Public SecElapsed As Integer
Public TimerDisplayHeight As Integer
Public TimerDisplayLeft As Integer
Public TimerDisplayTop As Integer
Public TimerDisplayWidth As Integer
Public Xunit As Integer
Public Yunit As Integer


'=================================== Pictures ==============================================
'
Public Bomb As Picture
Public Button As Picture
Public CellPic(9) As Picture
Public CellX As Picture
Public Explosion As Picture
Public Flag As Picture
Public QMark As Picture
Public NbrPic(10) As Picture
Public Minus As Picture
Public HappyFace As Picture
Public SurprisedFace As Picture
Public SadFace As Picture
Public CoolFace As Picture

Public Sub BlowUp()
Dim X As Integer
    DRGMineSweeper2.Timer1.Enabled = False
    GameOver = True
    DRGMineSweeper2.PaintPicture SadFace, FaceLeft, FaceTop
    For X = 0 To ((CellsAcross * CellsDown) - 1)
        With CellArray(X)
            If Not .Clicked Then
                If .Flagged And Not .Bomb Then
                    DRGMineSweeper2.PaintPicture CellX, _
                      CSng(((X Mod CellsAcross) * Xunit) + PlayFieldLeft), _
                      CSng(((X \ CellsAcross) * Yunit) + PlayFieldTop)
                ElseIf .Bomb Then
                    DRGMineSweeper2.PaintPicture Bomb, _
                      CSng(((X Mod CellsAcross) * Xunit) + PlayFieldLeft), _
                      CSng(((X \ CellsAcross) * Yunit) + PlayFieldTop)
                ElseIf DRGMineSweeper2.mnuGameDsplyAll.Checked Then
                    DRGMineSweeper2.PaintPicture CellPic(.BombsAbutting), _
                      CSng(((X Mod CellsAcross) * Xunit) + PlayFieldLeft), _
                      CSng(((X \ CellsAcross) * Yunit) + PlayFieldTop)
                End If
            End If
        End With
    Next X
End Sub

Private Sub Calculate_Bomb_Counts()
Dim X As Integer
Dim CellBombCnt As Integer
    For X = 0 To ((CellsAcross * CellsDown) - 1)
        If Not CellArray(X).Bomb Then
            CellBombCnt = 0
            If UpperLeftCell(X) <> -1 Then
                If CellArray(UpperLeftCell(X)).Bomb Then
                    CellBombCnt = CellBombCnt + 1
                End If
            End If
            If LeftCell(X) <> -1 Then
                If CellArray(LeftCell(X)).Bomb Then
                    CellBombCnt = CellBombCnt + 1
                End If
            End If
            If LowerLeftCell(X) <> -1 Then
                If CellArray(LowerLeftCell(X)).Bomb Then
                    CellBombCnt = CellBombCnt + 1
                End If
            End If
            If TopCell(X) <> -1 Then
                If CellArray(TopCell(X)).Bomb Then
                    CellBombCnt = CellBombCnt + 1
                End If
            End If
            If BottomCell(X) <> -1 Then
                If CellArray(BottomCell(X)).Bomb Then
                    CellBombCnt = CellBombCnt + 1
                End If
            End If
            If UpperRightCell(X) <> -1 Then
                If CellArray(UpperRightCell(X)).Bomb Then
                    CellBombCnt = CellBombCnt + 1
                End If
            End If
            If RightCell(X) <> -1 Then
                If CellArray(RightCell(X)).Bomb Then
                    CellBombCnt = CellBombCnt + 1
                End If
            End If
            If LowerRightCell(X) <> -1 Then
                If CellArray(LowerRightCell(X)).Bomb Then
                    CellBombCnt = CellBombCnt + 1
                End If
            End If
            CellArray(X).BombsAbutting = CellBombCnt
        End If
    Next X
End Sub

Public Sub CheckNeighbors(vCellClicked)
    If TopCell(vCellClicked) <> -1 Then
        With CellArray(TopCell(vCellClicked))
            If Not .Bomb And Not .Flagged And Not .Marked And Not .Clicked Then
                If .BombsAbutting = 0 Then
                    PushDown TopCell(vCellClicked), BlankCellStack
                Else
                    DRGMineSweeper2.PaintPicture CellPic(.BombsAbutting), _
                      CSng(((TopCell(vCellClicked) Mod CellsAcross) * Xunit) + PlayFieldLeft), _
                      CSng(((TopCell(vCellClicked) \ CellsAcross) * Yunit) + PlayFieldTop)
                    .Clicked = True
                    ClickedCnt = ClickedCnt + 1
                End If
            End If
        End With
    End If
    If BottomCell(vCellClicked) <> -1 Then
        With CellArray(BottomCell(vCellClicked))
            If Not .Bomb And Not .Flagged And Not .Marked And Not .Clicked Then
                If .BombsAbutting = 0 Then
                    PushDown BottomCell(vCellClicked), BlankCellStack
                Else
                    DRGMineSweeper2.PaintPicture CellPic(.BombsAbutting), _
                      CSng(((BottomCell(vCellClicked) Mod CellsAcross) * Xunit) + PlayFieldLeft), _
                      CSng(((BottomCell(vCellClicked) \ CellsAcross) * Yunit) + PlayFieldTop)
                    .Clicked = True
                    ClickedCnt = ClickedCnt + 1
                End If
            End If
        End With
    End If
    If UpperRightCell(vCellClicked) <> -1 Then
        With CellArray(UpperRightCell(vCellClicked))
            If Not .Bomb And Not .Flagged And Not .Marked And Not .Clicked Then
                If .BombsAbutting = 0 Then
                    PushDown UpperRightCell(vCellClicked), BlankCellStack
                Else
                    DRGMineSweeper2.PaintPicture CellPic(.BombsAbutting), _
                      CSng(((UpperRightCell(vCellClicked) Mod CellsAcross) * Xunit) + PlayFieldLeft), _
                      CSng(((UpperRightCell(vCellClicked) \ CellsAcross) * Yunit) + PlayFieldTop)
                    .Clicked = True
                    ClickedCnt = ClickedCnt + 1
                End If
            End If
        End With
    End If
    If RightCell(vCellClicked) <> -1 Then
        With CellArray(RightCell(vCellClicked))
            If Not .Bomb And Not .Flagged And Not .Marked And Not .Clicked Then
                If .BombsAbutting = 0 Then
                    PushDown RightCell(vCellClicked), BlankCellStack
                Else
                    DRGMineSweeper2.PaintPicture CellPic(.BombsAbutting), _
                      CSng(((RightCell(vCellClicked) Mod CellsAcross) * Xunit) + PlayFieldLeft), _
                      CSng(((RightCell(vCellClicked) \ CellsAcross) * Yunit) + PlayFieldTop)
                    .Clicked = True
                    ClickedCnt = ClickedCnt + 1
                End If
            End If
        End With
    End If
    If LowerRightCell(vCellClicked) <> -1 Then
        With CellArray(LowerRightCell(vCellClicked))
            If Not .Bomb And Not .Flagged And Not .Marked And Not .Clicked Then
                If .BombsAbutting = 0 Then
                    PushDown LowerRightCell(vCellClicked), BlankCellStack
                Else
                    DRGMineSweeper2.PaintPicture CellPic(.BombsAbutting), _
                      CSng(((LowerRightCell(vCellClicked) Mod CellsAcross) * Xunit) + PlayFieldLeft), _
                      CSng(((LowerRightCell(vCellClicked) \ CellsAcross) * Yunit) + PlayFieldTop)
                    .Clicked = True
                    ClickedCnt = ClickedCnt + 1
                End If
            End If
        End With
    End If
    If UpperLeftCell(vCellClicked) <> -1 Then
        With CellArray(UpperLeftCell(vCellClicked))
            If Not .Bomb And Not .Flagged And Not .Marked And Not .Clicked Then
                If .BombsAbutting = 0 Then
                    PushDown UpperLeftCell(vCellClicked), BlankCellStack
                Else
                    DRGMineSweeper2.PaintPicture CellPic(.BombsAbutting), _
                      CSng(((UpperLeftCell(vCellClicked) Mod CellsAcross) * Xunit) + PlayFieldLeft), _
                      CSng(((UpperLeftCell(vCellClicked) \ CellsAcross) * Yunit) + PlayFieldTop)
                    .Clicked = True
                    ClickedCnt = ClickedCnt + 1
                End If
            End If
        End With
    End If
    If LeftCell(vCellClicked) <> -1 Then
        With CellArray(LeftCell(vCellClicked))
            If Not .Bomb And Not .Flagged And Not .Marked And Not .Clicked Then
                If .BombsAbutting = 0 Then
                    PushDown LeftCell(vCellClicked), BlankCellStack
                Else
                    DRGMineSweeper2.PaintPicture CellPic(.BombsAbutting), _
                      CSng(((LeftCell(vCellClicked) Mod CellsAcross) * Xunit) + PlayFieldLeft), _
                      CSng(((LeftCell(vCellClicked) \ CellsAcross) * Yunit) + PlayFieldTop)
                    .Clicked = True
                    ClickedCnt = ClickedCnt + 1
                End If
            End If
        End With
    End If
    If LowerLeftCell(vCellClicked) <> -1 Then
        With CellArray(LowerLeftCell(vCellClicked))
            If Not .Bomb And Not .Flagged And Not .Marked And Not .Clicked Then
                If .BombsAbutting = 0 Then
                    PushDown LowerLeftCell(vCellClicked), BlankCellStack
                Else
                    DRGMineSweeper2.PaintPicture CellPic(.BombsAbutting), _
                      CSng(((LowerLeftCell(vCellClicked) Mod CellsAcross) * Xunit) + PlayFieldLeft), _
                      CSng(((LowerLeftCell(vCellClicked) \ CellsAcross) * Yunit) + PlayFieldTop)
                    .Clicked = True
                    ClickedCnt = ClickedCnt + 1
                End If
            End If
        End With
    End If
End Sub

Private Sub Display_FlagCount()
Dim PicIndx As Integer
    With DRGMineSweeper2
        If FlagCnt < 0 Then
            .PaintPicture Minus, FlagCounterLeft, FlagCounterTop
        Else
            PicIndx = Abs(FlagCnt) \ 100
            .PaintPicture NbrPic(PicIndx), FlagCounterLeft, FlagCounterTop
        End If
        PicIndx = (Abs(FlagCnt) \ 10) Mod 10
        .PaintPicture NbrPic(PicIndx), (FlagCounterLeft + NumberWidth), FlagCounterTop
        PicIndx = Abs(FlagCnt) Mod 10
        .PaintPicture NbrPic(PicIndx), (FlagCounterLeft + (2 * NumberWidth)), FlagCounterTop
    End With
End Sub


Public Sub Display_SecElapsed()
Dim PicIndx As Integer
    With DRGMineSweeper2
        PicIndx = SecElapsed \ 100
        .PaintPicture NbrPic(PicIndx), TimerDisplayLeft, TimerDisplayTop
        PicIndx = (SecElapsed \ 10) Mod 10
        .PaintPicture NbrPic(PicIndx), (TimerDisplayLeft + NumberWidth), TimerDisplayTop
        PicIndx = SecElapsed Mod 10
        .PaintPicture NbrPic(PicIndx), (TimerDisplayLeft + (2 * NumberWidth)), TimerDisplayTop
    End With

End Sub

Private Sub Draw_Border(vLeft As Single, vTop As Single, vWidth As Single, vHeight As Single, _
                        vBorderwidth As Single, vBevelThickness As Integer)
Dim i As Integer
Dim InX0 As Single, InX1 As Single, InY0 As Single, InY1 As Single
Dim OutX0 As Single, OutX1 As Single, OutY0 As Single, OutY1 As Single
'
'
'
'                         ________________________________________________________________________
'         vBevelThickness----{ | ____________________________________________________________________  |
'                         | |\                            \                                    /| |
'                         | | \                            \- vBorderwidth                    / | |
'                         | | (OutX0,OutY0)                /                      (OutX1,OutY1) | |
'                         | |      _______________________/_____________________________        | |
'                 vBevelThickness----{ |  _________________________________________________  |       |
'                           |     | |\                                               /| |       |
'                                 | | \                                             / | |       |
'                                 | |(InX0,InY0)                          (InX1,InY1) | |       |
'
'

    InX0 = vLeft
    InY0 = vTop
    InX1 = vLeft + vWidth
    InY1 = vTop + vHeight
    OutX0 = vLeft - vBorderwidth - vBevelThickness
    OutY0 = vTop - vBorderwidth - vBevelThickness
    OutX1 = vLeft + vWidth + vBorderwidth + vBevelThickness
    OutY1 = vTop + vHeight + vBorderwidth + vBevelThickness
    
    For i = 0 To vBevelThickness
            DRGMineSweeper2.Line (InX0 - i, InY0 - i)-(InX1 + i, InY0 - i), vbButtonShadow
            DRGMineSweeper2.Line (InX0 - i, InY0 - i)-(InX0 - i, InY1 + i), vbButtonShadow
            DRGMineSweeper2.Line (InX0 - i, InY1 + i)-(InX1 + i, InY1 + i), vb3DHighlight
            DRGMineSweeper2.Line (InX1 + i, InY1 + i)-(InX1 + i, InY0 - i), vb3DHighlight

            DRGMineSweeper2.Line (OutX0 - i, OutY0 - i)-(OutX1 + i, OutY0 - i), vb3DHighlight
            DRGMineSweeper2.Line (OutX0 - i, OutY0 - i)-(OutX0 - i, OutY1 + i), vb3DHighlight
            DRGMineSweeper2.Line (OutX0 - i, OutY1 + i)-(OutX1 + i, OutY1 + i), vbButtonShadow
            DRGMineSweeper2.Line (OutX1 + i, OutY1 + i)-(OutX1 + i, OutY0 - i), vbButtonShadow
            
            DRGMineSweeper2.Line (InX0 - i, (InY0 + BorderGirth + FlagCounterHeight + 8) - i)- _
              (InX1 + i, (InY0 + BorderGirth + FlagCounterHeight + 8) - i), vbButtonShadow
            DRGMineSweeper2.Line (InX0 + i, (OutY0 + BorderGirth + FlagCounterHeight + 8) - i)- _
              (InX1 + i, (OutY0 + BorderGirth + FlagCounterHeight + 8) - i), vb3DHighlight
            DRGMineSweeper2.Line (InX0 - i, (InY0 + BorderGirth + FlagCounterHeight + 8) - (vBevelThickness + 1))- _
              (InX0 - i, (OutY0 + BorderGirth + FlagCounterHeight + 8)), vbButtonFace
            DRGMineSweeper2.Line (InX1 + i, (InY0 + BorderGirth + FlagCounterHeight + 8) - (vBevelThickness + 1))- _
              (InX1 + i, (OutY0 + BorderGirth + FlagCounterHeight + 8)), vbButtonFace

       Next i
End Sub

Private Sub Game_Won()
    DRGMineSweeper2.Timer1.Enabled = False
    GameOver = True
    If FlagCnt > 0 Then
        Dim X As Integer
        For X = 0 To ((CellsAcross * CellsDown) - 1)
            With CellArray(X)
            If .Bomb And Not .Flagged Then
                DRGMineSweeper2.PaintPicture Flag, _
                  CSng(((X Mod CellsAcross) * Xunit) + PlayFieldLeft), _
                  CSng(((X \ CellsAcross) * Yunit) + PlayFieldTop)
                .Flagged = True
                FlagCnt = FlagCnt - 1
                Call Display_FlagCount
            End If
            End With
        Next X
    End If
    DRGMineSweeper2.PaintPicture CoolFace, FaceLeft, FaceTop
    If SecElapsed < BestTimes(PlayLevel) Then
        BestTimes(PlayLevel) = SecElapsed
        NewBestTime = True
        frmBestTimes.Show vbModal
        NewBestTime = False
    End If
End Sub

Private Sub Generate_Bomb_Pattern()
Dim X As Integer
Dim BombsGenerated As Integer
    Randomize
    Do Until BombsGenerated = BombNbr
        X = Int(((CellsAcross * CellsDown) - 1) * Rnd)
        If Not CellArray(X).Bomb Then
            CellArray(X).Bomb = True
            BombsGenerated = BombsGenerated + 1
        End If
    Loop
  End Sub

Private Sub Init_CellArray()
Dim X As Integer
    For X = 0 To ((CellsAcross * CellsDown) - 1)
        With CellArray(X)
            .Bomb = False
            .BombsAbutting = 0
            .Clicked = False
            .Flagged = False
            .Marked = False
        End With
    Next X
End Sub


Public Sub Init_Game()
    ReDim Preserve BlankCellStack(0)
    ReDim CellArray(CellsDown * CellsAcross)
    DRGMineSweeper2.Cls
    With DRGMineSweeper2
        Call Draw_Border(BorderGirth, BorderGirth, (.ScaleWidth - (2 * BorderGirth)), _
          (.ScaleHeight - 2 * BorderGirth), BorderWidth, BevelThickness)
        .Visible = True
        Call Setup_NewGame
        .Refresh
    End With
    
End Sub

Private Sub Init_Opening_Game_Values()
Dim i As Integer
Dim j As Integer
    With DRGMineSweeper2
        For i = 0 To (CellsAcross - 1)
            For j = 0 To (CellsDown - 1)
                .PaintPicture Button, (PlayFieldLeft + (i * Xunit)), (PlayFieldTop + (j * Yunit))
            Next j
        Next i
        .PaintPicture HappyFace, FaceLeft, FaceTop
        .Timer1.Enabled = False
    End With
    FlagCnt = BombNbr
    ClickedCnt = 0
    Call Display_FlagCount
    SecElapsed = 0
    Call Display_SecElapsed
    NewBestTime = False
    GameOver = False
    GameStarted = False

End Sub

Public Sub LeftClick(vCellClicked As Integer, vX As Single, vY As Single)
    With CellArray(vCellClicked)
        If Not .Clicked And Not .Flagged And Not .Marked Then
            If .Bomb Then
                DRGMineSweeper2.PaintPicture Explosion, _
                  CSng(((vCellClicked Mod CellsAcross) * Xunit) + PlayFieldLeft), _
                  CSng(((vCellClicked \ CellsAcross) * Yunit) + PlayFieldTop)
                Call BlowUp
            ElseIf .BombsAbutting = 0 Then
                PushDown vCellClicked, BlankCellStack
                Call Process_BlankCell
            Else
                DRGMineSweeper2.PaintPicture CellPic(.BombsAbutting), _
                  CSng(((vCellClicked Mod CellsAcross) * Xunit) + PlayFieldLeft), _
                  CSng(((vCellClicked \ CellsAcross) * Yunit) + PlayFieldTop)
                .Clicked = True
                ClickedCnt = ClickedCnt + 1
            End If
        End If
    End With
    If ClickedCnt = ((CellsAcross * CellsDown) - BombNbr) Then
        Call Game_Won
    End If
End Sub


Public Sub Load_Pics()
Dim PicPrefix As String
     PicPrefix = ""
     With DRGMineSweeper2
        If .mnuGameBigBtns.Checked Then
            PicPrefix = "Big"
        End If

         With .ImageList1
            Set Bomb = .ListImages(PicPrefix & "Bomb").Picture
            Set Button = .ListImages(PicPrefix & "Button").Picture
            Set CellPic(0) = .ListImages(PicPrefix & "Cell0").Picture
            Set CellPic(1) = .ListImages(PicPrefix & "Cell1").Picture
            Set CellPic(2) = .ListImages(PicPrefix & "Cell2").Picture
            Set CellPic(3) = .ListImages(PicPrefix & "Cell3").Picture
            Set CellPic(4) = .ListImages(PicPrefix & "Cell4").Picture
            Set CellPic(5) = .ListImages(PicPrefix & "Cell5").Picture
            Set CellPic(6) = .ListImages(PicPrefix & "Cell6").Picture
            Set CellPic(7) = .ListImages(PicPrefix & "Cell7").Picture
            Set CellPic(8) = .ListImages(PicPrefix & "Cell8").Picture
            Set CellX = .ListImages(PicPrefix & "CellX").Picture
            Set Explosion = .ListImages(PicPrefix & "Explosion").Picture
            Set Flag = .ListImages(PicPrefix & "Flag").Picture
            Set QMark = .ListImages(PicPrefix & "QMark").Picture
            Set NbrPic(0) = .ListImages(PicPrefix & "Zero").Picture
            Set NbrPic(1) = .ListImages(PicPrefix & "One").Picture
            Set NbrPic(2) = .ListImages(PicPrefix & "Two").Picture
            Set NbrPic(3) = .ListImages(PicPrefix & "Three").Picture
            Set NbrPic(4) = .ListImages(PicPrefix & "Four").Picture
            Set NbrPic(5) = .ListImages(PicPrefix & "Five").Picture
            Set NbrPic(6) = .ListImages(PicPrefix & "Six").Picture
            Set NbrPic(7) = .ListImages(PicPrefix & "Seven").Picture
            Set NbrPic(8) = .ListImages(PicPrefix & "Eight").Picture
            Set NbrPic(9) = .ListImages(PicPrefix & "Nine").Picture
            Set Minus = .ListImages(PicPrefix & "Minus").Picture
            Set HappyFace = .ListImages(PicPrefix & "HappyFace").Picture
            Set SurprisedFace = .ListImages(PicPrefix & "SurprisedFace").Picture
            Set SadFace = .ListImages(PicPrefix & "SadFace").Picture
            Set CoolFace = .ListImages(PicPrefix & "CoolFace").Picture
        End With
        
        Xunit = .ScaleX(Button.Width, vbHimetric, vbPixels)
        Yunit = .ScaleY(Button.Height, vbHimetric, vbPixels)
        FaceWidth = .ScaleX(HappyFace.Width, vbHimetric, vbPixels)
        FaceHeight = .ScaleY(HappyFace.Height, vbHimetric, vbPixels)
        FlagCounterWidth = 3 * (.ScaleX(NbrPic(0).Width, vbHimetric, vbPixels))
        FlagCounterHeight = .ScaleY(NbrPic(0).Height, vbHimetric, vbPixels)
        TimerDisplayWidth = 3 * (.ScaleX(NbrPic(0).Width, vbHimetric, vbPixels))
        TimerDisplayHeight = .ScaleY(NbrPic(0).Height, vbHimetric, vbPixels)
        NumberWidth = .ScaleX(NbrPic(0).Width, vbHimetric, vbPixels)
    End With
End Sub

Private Sub Process_BlankCell()
Dim StackItem
    StackItem = PopUp(BlankCellStack)
    Do Until IsError(StackItem)
        If Not CellArray(StackItem).Clicked Then
            DRGMineSweeper2.PaintPicture CellPic(0), _
              CSng(((StackItem Mod CellsAcross) * Xunit) + PlayFieldLeft), _
              CSng(((StackItem \ CellsAcross) * Yunit) + PlayFieldTop)
            CellArray(StackItem).Clicked = True
            ClickedCnt = ClickedCnt + 1
            Call CheckNeighbors(StackItem)
        End If
        StackItem = PopUp(BlankCellStack)
    Loop

End Sub


Public Sub Read_Parms()
Dim MarksSw As Boolean
Dim DsplyAllSw As Boolean
Dim BigButtonsSw As Boolean
On Error GoTo Open_Error
    Open App.Path & "\DRGMSwpr.drg" For Input As #1
    With DRGMineSweeper2
        Input #1, PlayLevel, CellsAcross, CellsDown, BombNbr, _
          MarksSw, FrmLeft, FrmTop, _
          BestTimes(0), BestTimes(1), BestTimes(2), _
          BestNames(0), BestNames(1), BestNames(2), _
          DsplyAllSw, BigButtonsSw
        .mnuGameMarks.Checked = MarksSw
        .mnuGameDsplyAll.Checked = DsplyAllSw
        .mnuGameBigBtns.Checked = BigButtonsSw
        If PlayLevel = DRGBeginner Then
            .mnuGameBeginner.Checked = True
            .mnuGameCustom.Checked = False
            .mnuGameExpert.Checked = False
            .mnuGameIntermed.Checked = False
        ElseIf PlayLevel = DRGCustom Then
            .mnuGameBeginner.Checked = False
            .mnuGameCustom.Checked = True
            .mnuGameExpert.Checked = False
            .mnuGameIntermed.Checked = False
        ElseIf PlayLevel = DRGExpert Then
            .mnuGameBeginner.Checked = False
            .mnuGameCustom.Checked = False
            .mnuGameExpert.Checked = True
            .mnuGameIntermed.Checked = False
        ElseIf PlayLevel = DRGIntermediate Then
            .mnuGameBeginner.Checked = False
            .mnuGameCustom.Checked = False
            .mnuGameExpert.Checked = False
            .mnuGameIntermed.Checked = True
        End If
    End With
    Close
Exit Sub

Open_Error:
    With DRGMineSweeper2
        If Err.Number = 53 Then
            PlayLevel = DRGBeginner
            .mnuGameBeginner.Checked = True
            CellsAcross = BeginnerCellsAcross
            CellsDown = BeginnerCellsDown
            BombNbr = BeginnerBombNbr
            .mnuGameMarks.Checked = True
            .mnuGameDsplyAll.Checked = False
            .mnuGameBigBtns.Checked = False
            FrmLeft = 0
            FrmTop = 0
            Dim X As Integer
            For X = 0 To 2
                BestTimes(X) = 999
                BestNames(X) = ""
            Next X
        Else
            Err.Raise Err.Number, Err.Source, Err.Description
        End If
    End With

End Sub


Public Sub RightClick(vCellClicked)
    With CellArray(vCellClicked)
        If Not .Clicked Then
            If .Flagged Then
                .Flagged = False
                FlagCnt = FlagCnt + 1
                Call Display_FlagCount
                If .Bomb Then
                    BombCnt = BombCnt - 1  '****************************************************************
                End If
                If DRGMineSweeper2.mnuGameMarks.Checked Then
                    .Marked = True
                    DRGMineSweeper2.PaintPicture QMark, _
                      CSng(((vCellClicked Mod CellsAcross) * Xunit) + PlayFieldLeft), _
                      CSng(((vCellClicked \ CellsAcross) * Yunit) + PlayFieldTop)
                Else
                    DRGMineSweeper2.PaintPicture Button, _
                      CSng(((vCellClicked Mod CellsAcross) * Xunit) + PlayFieldLeft), _
                      CSng(((vCellClicked \ CellsAcross) * Yunit) + PlayFieldTop)
                End If
            ElseIf .Marked Then
                .Marked = False
                DRGMineSweeper2.PaintPicture Button, _
                  CSng(((vCellClicked Mod CellsAcross) * Xunit) + PlayFieldLeft), _
                  CSng(((vCellClicked \ CellsAcross) * Yunit) + PlayFieldTop)
            Else
                .Flagged = True
                FlagCnt = FlagCnt - 1
                Call Display_FlagCount
                If .Bomb Then
                    BombCnt = BombCnt + 1  '*************************************************************
                End If
                DRGMineSweeper2.PaintPicture Flag, _
                  CSng(((vCellClicked Mod CellsAcross) * Xunit) + PlayFieldLeft), _
                  CSng(((vCellClicked \ CellsAcross) * Yunit) + PlayFieldTop)
            End If
        End If
    End With
End Sub

Public Sub Setup_NewGame()
    Call Init_CellArray
    Call Generate_Bomb_Pattern
    Call Calculate_Bomb_Counts
    Call Init_Opening_Game_Values
End Sub

Public Sub Setup_Replay()
Dim X As Integer
    For X = 0 To ((CellsAcross * CellsDown) - 1)
        With CellArray(X)
            .Clicked = False
            .Flagged = False
            .Marked = False
        End With
    Next X
    Call Init_Opening_Game_Values
End Sub
 
Public Sub Size_Form()
    FlagCounterLeft = BorderGirth + 3
    FlagCounterTop = BorderGirth + 4
    TimerDisplayTop = BorderGirth + 4
    FaceTop = BorderGirth + 4
    PlayFieldTop = (2 * BorderGirth) + FlagCounterHeight + 9
    PlayFieldLeft = BorderGirth + 1
    PlayFieldWidth = (CellsAcross * Xunit)
    PlayFieldHeight = (CellsDown * Yunit)
    With DRGMineSweeper2
        .Width = ((PlayFieldWidth + 2) + (2 * BorderGirth) + FormSideBorderWidth) * TwipsPerPixel
        .Height = ((PlayFieldHeight + 2) + (3 * BorderGirth) + (FlagCounterHeight + 6) + FormTopBorderWidth) * TwipsPerPixel
        FaceLeft = (.ScaleWidth - FaceWidth) / 2
        TimerDisplayLeft = .ScaleWidth - (TimerDisplayWidth + BorderGirth + 3)
    End With
 
End Sub
 
 
Public Sub UnDo_Routine(vLastCellClicked)
Dim X As Integer
    ClickedCnt = 0
    For X = 0 To ((CellsAcross * CellsDown) - 1)
        With CellArray(X)
            If Not .Clicked Then
                If .Flagged Then
                    DRGMineSweeper2.PaintPicture Flag, _
                      CSng(((X Mod CellsAcross) * Xunit) + PlayFieldLeft), _
                      CSng(((X \ CellsAcross) * Yunit) + PlayFieldTop)
                ElseIf .Marked Then
                    DRGMineSweeper2.PaintPicture QMark, _
                      CSng(((X Mod CellsAcross) * Xunit) + PlayFieldLeft), _
                      CSng(((X \ CellsAcross) * Yunit) + PlayFieldTop)
                Else
                    DRGMineSweeper2.PaintPicture Button, _
                      CSng(((X Mod CellsAcross) * Xunit) + PlayFieldLeft), _
                      CSng(((X \ CellsAcross) * Yunit) + PlayFieldTop)
                End If
            Else
                ClickedCnt = ClickedCnt + 1
            End If
        End With
    Next X
    NewBestTime = False
    GameOver = False
    DRGMineSweeper2.PaintPicture HappyFace, FaceLeft, FaceTop
    DRGMineSweeper2.Timer1.Enabled = True
        
End Sub

Public Sub Write_Parms()
On Error Resume Next
    Open App.Path & "\DRGMSwpr.drg" For Output As #1
    With DRGMineSweeper2
    
' If the game is minimized when ended, the form's .Top and .Left values will be set to 45000 which will cause
' an overflow error when the game is reopened.

        If .WindowState <> vbMinimized Then
            FrmTop = .Top
            FrmLeft = .Left
        Else
            FrmTop = 0
            FrmLeft = 0
        End If
        Write #1, PlayLevel, CellsAcross, CellsDown, BombNbr, _
          .mnuGameMarks.Checked, FrmLeft, FrmTop, _
          BestTimes(0), BestTimes(1), BestTimes(2), _
          BestNames(0), BestNames(1), BestNames(2), _
          .mnuGameDsplyAll.Checked, .mnuGameBigBtns.Checked
    End With
    Close
End Sub


 
'
'---------- FUNCTIONS ----------------------------------------------------------------------
'
'
Private Function UpperLeftCell(ByVal vCell As Integer) As Integer
    If vCell > ((CellsAcross * CellsDown) - 1) Then
        UpperLeftCell = -1
    ElseIf vCell Mod CellsAcross = 0 Or vCell < CellsAcross Then
        UpperLeftCell = -1
    Else
        UpperLeftCell = vCell - (CellsAcross + 1)
    End If
End Function


Private Function LeftCell(ByVal vCell As Integer) As Integer
    If vCell > ((CellsAcross * CellsDown) - 1) Then
        LeftCell = -1
    ElseIf vCell Mod CellsAcross = 0 Then
        LeftCell = -1
    Else
        LeftCell = vCell - 1
    End If
End Function

Private Function LowerLeftCell(ByVal vCell As Integer) As Integer
    If vCell > ((CellsAcross * CellsDown) - 1) Then
        LowerLeftCell = -1
    ElseIf vCell Mod CellsAcross = 0 Or vCell > ((CellsDown - 1) * CellsAcross) - 1 Then
        LowerLeftCell = -1
    Else
        LowerLeftCell = vCell + CellsAcross - 1
    End If

End Function

Private Function TopCell(ByVal vCell As Integer) As Integer
    If vCell > ((CellsAcross * CellsDown) - 1) Then
        TopCell = -1
    ElseIf vCell < CellsAcross Then
        TopCell = -1
    Else
        TopCell = vCell - CellsAcross
    End If

End Function

Private Function BottomCell(ByVal vCell As Integer) As Integer
    If vCell > ((CellsAcross * CellsDown) - 1) Then
        BottomCell = -1
    ElseIf vCell > ((CellsDown - 1) * CellsAcross) - 1 Then
        BottomCell = -1
    Else
        BottomCell = vCell + CellsAcross
    End If
End Function

Private Function UpperRightCell(ByVal vCell As Integer) As Integer
    If vCell > ((CellsAcross * CellsDown) - 1) Then
        UpperRightCell = -1
    ElseIf vCell Mod CellsAcross = (CellsAcross - 1) Or vCell < CellsAcross Then
        UpperRightCell = -1
    Else
        UpperRightCell = vCell - CellsAcross + 1
    End If
End Function

Private Function RightCell(ByVal vCell As Integer) As Integer
    If vCell > ((CellsAcross * CellsDown) - 1) Then
        RightCell = -1
    ElseIf vCell Mod CellsAcross = (CellsAcross - 1) Then
        RightCell = -1
    Else
        RightCell = vCell + 1
    End If
End Function

Private Function LowerRightCell(ByVal vCell As Integer) As Integer
    If vCell > ((CellsAcross * CellsDown) - 1) Then
        LowerRightCell = -1
    ElseIf vCell Mod CellsAcross = (CellsAcross - 1) Or vCell > ((CellsDown - 1) * CellsAcross) - 1 Then
        LowerRightCell = -1
    Else
        LowerRightCell = vCell + CellsAcross + 1
    End If
End Function

Private Function PushDown(vElement As Variant, vStack() As Variant)
Dim i As Long
    ReDim Preserve vStack(UBound(vStack) + 1)
    For i = UBound(vStack) - 1 To LBound(vStack) Step -1
        vStack(i + 1) = vStack(i)
    Next i
    vStack(LBound(vStack)) = vElement
End Function

Private Function PopUp(vStack() As Variant) As Variant
Dim i As Long
    If UBound(vStack) <> 0 Then
        PopUp = vStack(LBound(vStack))
        For i = LBound(vStack) + 1 To UBound(vStack)
            vStack(i - 1) = vStack(i)
        Next i
        If UBound(vStack) <> LBound(vStack) Then
            ReDim Preserve vStack(UBound(vStack) - 1)
        End If
    Else
        PopUp = CVErr(666)
    End If
End Function

